# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..37\n"; }
END {print "not ok 1\n" unless $loaded;}
use GrabEnv qw( grabenv grabenv_File grabenv_Expect diffenv );
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

my $test = 1;

for my $opt ( undef, { Startup => 1 } )
{
  loop( \&grabenv, $opt );
  loop( \&grabenv_File, $opt );
  loop( \&grabenv_Expect, $opt );
}


sub loop
{
  my ( $grabenv, $opt ) = @_;

  my %newENV;

  $test++;
  %newENV = ();
  %newENV = $grabenv->( 'csh', 'source testenv.csh', undef, $opt );
  print 'not ' unless defined $newENV{GRABENV} && $newENV{GRABENV} eq 'csh';
  print "ok $test\n";
  
  
  $test++;
  %newENV = ();
  %newENV = $grabenv->( 'tcsh', 'source testenv.tcsh', undef, $opt );
  print 'not ' unless defined $newENV{GRABENV} && $newENV{GRABENV} eq 'tcsh';
  print "ok $test\n";
  
  
  $test++;
  %newENV = ();
  %newENV = $grabenv->( 'sh', '. ./testenv.sh', undef, $opt );
  print 'not ' unless defined $newENV{GRABENV} && $newENV{GRABENV} eq 'sh';
  print "ok $test\n";
  
  
  $test++;
  %newENV = ();
  %newENV = $grabenv->( 'ksh', '. ./testenv.ksh', undef, $opt );
  print 'not ' unless defined $newENV{GRABENV} && $newENV{GRABENV} eq 'ksh';
  print "ok $test\n";
  
  $test++;
  %newENV = %ENV;
  $newENV{FOO} = '2';
  my %diffENV = diffenv( \%newENV );
  print 'not ' 
    unless keys %diffENV == 1 && defined $diffENV{FOO} && 
      $diffENV{FOO} eq '2';
  print "ok $test\n";
  
  
  $test++;
  %newENV = ();
  my %oldENV = $grabenv->( 'ksh', 'export FOO=1', undef, $opt );
  %newENV = $grabenv->( 'ksh', 'export FOO=2', undef, $opt );
  my %diffENV = diffenv( \%newENV, \%oldENV );
  
  print 'not ' 
    unless keys %diffENV == 1 && defined $diffENV{FOO} && 
      $diffENV{FOO} eq '2';
  print "ok $test\n";
  
}
